Subject: Re: linux-next: build failure after merge of the nfsd tree

From: Stanislav Kinsbursky <[email-masked]>
Date: Fri, 8 Feb 2013 09:41:05 +0400

03.02.2013 18:41, J. Bruce Fields пишет:
> On Sat, Feb 02, 2013 at 07:57:19AM -0500, J. Bruce Fields wrote:
>> On Sat, Feb 02, 2013 at 01:04:03PM +1100, Stephen Rothwell wrote:
>>> Hi,
>>>
>>> After merging the nfsd tree, today's linux-next build (x86_64
>>> allmodconfig) failed like this:
>>>
>>> fs/nfs/dns_resolve.c: In function 'nfs_dns_resolver_cache_init':
>>> fs/nfs/dns_resolve.c:375:4: error: 'struct cache_detail' has no member named 'cache_upcall'
>>> fs/nfs/dns_resolve.c:375:35: warning: left-hand operand of comma expression has no effect [-Wunused-value]
>>> fs/nfs/dns_resolve.c:375:35: warning: value computed is not used [-Wunused-value]
>>> fs/nfs/dns_resolve.c:375:35: warning: value computed is not used [-Wunused-value]
>>> fs/nfs/dns_resolve.c:375:35: warning: value computed is not used [-Wunused-value]
>>> fs/nfs/dns_resolve.c:375:35: warning: value computed is not used [-Wunused-value]
>>> fs/nfs/dns_resolve.c:375:35: warning: value computed is not used [-Wunused-value]
>>> fs/nfs/dns_resolve.c:375:35: warning: value computed is not used [-Wunused-value]
>>>
>>> Caused by commit aab982cb5dfb ("SUNRPC: remove cache_detail->cache_upcall
>>> callback").
>>
>> Yes, I knew why we'd introduced cache_upcall, so I'm not sure how I
>> overlooked that.  It must have slipped through testing because I didn't
>> set CONFIG_NFS_USE_KERNEL_DNS.
>>
>> We may just be able to revert that patch....  I can take care of that by
>> tomorrow.
>
> Stanislav, any objections to this?
>

The only objection is that I've sent you the patch set witch fixes all these problems already:

"[PATCH v2 0/6] SUNRPC: rework cache upcall to avoid NFSd root". :)

The only reason why I removed cache_upcall at all was that all it's users (except NFS DNS cache - my mistake) just call sunrpc_cache_pipe_upcall and thus these 
wrapper looked redundant to me.
Second patch set leaves cache_upcall only for NFS DNS cache (since this upcall is not just a wrapper around sunrpc_cache_pipe_upcall).
And second patch set implies the first one will be dropped.
I can, actually, send one more (incremental  this time) patch set to fix the problem, if you wish.

But it's up to you, what to commit, Bruce.

-- 
Best regards,
Stanislav Kinsbursky